/* --- GaussElim performs the gaussian elimination algorithm -----------

   Input: The coefficients of a linear system and its constant vector.
   Return: The solution to the linear system.
------------------------------------------------------------------------*/

#include "Matrix.h"

#include <stdlib.h>

void ReadEquations(Matrix& AugMat);
int Reduce(Matrix& AugMat);
Matrix Solve(Matrix& AugMat);

Matrix GaussElim(void)
{
  Matrix                        // construct an empty matrix
     AugMat;

  ReadEquations(AugMat);        // fill it with coefficients and constants

  int
     Singular = Reduce(AugMat); // reduce to triangular form

  if (Singular)                 // check for singularity
  {
     cerr << "\n*** GaussElim: Linear system is (nearly) singular!\n";
     exit (0);
  }

  Matrix
     SolVect = Solve(AugMat);   // solve from triangular form

  return SolVect;               // return solution
}
