/* This program converts a temperature from Fahrenheit to Celsius,
   using a variety of functions.

   Input:   FahrenheitTemp
   Output:  CelsiusTemp
------------------------------------------------------------------*/

#include <iostream.h>

double GetFahrTemperature(void);        // \
double FahrToCelsius(double);           //  function declarations
void DisplayResult(double, double);     // /

int main(void)
{
   cout << "\nThis program converts a temperature\n"
        << "\tfrom Fahrenheit to Celsius.\n";

   double
      FahrenheitTemp = GetFahrTemperature();

   double
      CelsiusTemp = FahrToCelsius(FahrenheitTemp);

   DisplayResult(FahrenheitTemp, CelsiusTemp);

   return 0;
}  

/*-----------------------------------------------------------------
GetFahrTemperature is an operation to input a temperature.

   Output:  A prompt to the user
   Input:   A temperature
   Return:  The temperature that was input
------------------------------------------------------------------*/

double GetFahrTemperature(void)
{
   double Temp;

   cout << "\nPlease enter a Fahrenheit temperature: ";
   cin >> Temp;
   return Temp;
}

/*----------------------------------------------------------------
FahrToCelsius converts a temperature from Fahrenheit to Celsius.

   Receive:  A Fahrenheit temperature
   Return:   The equivalent Celsius temperature
------------------------------------------------------------------*/

double FahrToCelsius(double Temp)
{
   return (Temp - 32.0) / 1.8;
}

/*-----------------------------------------------------------------
DisplayResult outputs the original and converted temperatures.

   Receive:  The Fahrenheit temperature and its Celsius equivalent
   Output:   The two temperatures and appropriate labels
------------------------------------------------------------------*/

void DisplayResult(double OriginalTemp, double EquivalentTemp)
{
   cout << "\n\t" << OriginalTemp
        << " in Fahrenheit is equivalent to "
        << EquivalentTemp << " in Celsius.\n\n";
}
