/* This file provides an interface for library Times.

   Names declared:
     DaysToSeconds, a function to compute the number of seconds,
                       given a number of days
     DaysToHours, a function to compute the number of hours,
                       given a number of days
     HoursToMinutes, a function to compute the number of minutes,
                       given a number of hours
     MinutesToSeconds, a function to compute the number of seconds,
                       given a number of minutes
     ...
------------------------------------------------------------------*/

/*-----------------------------------------------------------------
DaysToSeconds computes the number of seconds in a given number
   of days.

   Receive: Days, a (double) number of days
   Return:  The equivalent (double) number of seconds
-------------------------------------------------------------------*/

double DaysToSeconds(double Days);

/*-----------------------------------------------------------------
DaysToHours computes the number of hours in a given number of days.

   Receive: Days, a (double) number of days
   Return:  The equivalent (double) number of hours
-------------------------------------------------------------------*/

double DaysToHours(double Days);

/*-----------------------------------------------------------------
HoursToMinutes computes the number of minutes in a given number
   of hours.

   Receive: Hours, a (double) number of hours
   Return:  The equivalent (double) number of minutes
-------------------------------------------------------------------*/

double HoursToMinutes(double Hours);

/*-----------------------------------------------------------------
MinutesToSeconds computes the number of seconds in a given number
   of minutes.

   Receive: Minutes, a (double) number of minutes
   Return:  The equivalent (double) number of seconds
-------------------------------------------------------------------*/

double MinutesToSeconds(double Minutes);

// ... declarations of additional time-related functions are omitted.
