/* This program computes a final course average using the homework
   average, the average on tests, and a final exam score; and
   assigns a pass/fail grade.

   Input:  Three real values representing a student's homework
           average, average on tests, and a final exam score
   Output:  The weighted average and the pass/fail grade
------------------------------------------------------------------*/

#include <iostream.h>

char LetterGrade(double);

int main(void)
{
   const double
      HWWeight = 0.2,         // weight factors for homework,
      TestWeight = 0.5,       //    tests,
      ExamWeight = 0.3;       //    and the exam.

   cout << "\nThis program computes a final course average using the"
        << "\n\thomework average, test average, and a final exam "
        << "score.\n";

   cout << "\nPlease enter homework average, test average, "
        << "and exam score:\n";

   double
      HomeworkAverage,        // the average of the homework scores
      TestAverage,            // the average of the test scores
      ExamScore;              // the final exam score

   cin >> HomeworkAverage >> TestAverage >> ExamScore;

   double
      Average = HWWeight * HomeworkAverage + TestWeight * TestAverage
              + ExamWeight * ExamScore;

   char
      Grade = LetterGrade(Average);    // the grade received (P or F)

   cout << "Average = " << Average << ", Grade = " << Grade << "\n\n";

   return 0;
}

/*---------------------------------------------------------------
LetterGrade computes a letter grade, given a weighted average.

   Receive: A (double) weighted average
   Return:  The appropriate (char) letter grade
------------------------------------------------------------------*/

char LetterGrade(double Average)
{
   const double
      PassFailLine = 60.0;    // pass/fail line

   if (Average >= PassFailLine)
      return 'P';
   else
      return 'F';
}
