/* This program computes a final course average using the homework
   average, the average on tests, and a final exam score; and
   assigns a pass/fail grade (version 4).

   Input:  Three real values representing a student's homework
           average, average on tests, and a final exam score
   Output:  The weighted average and the pass/fail grade
------------------------------------------------------------------*/

#include <iostream.h>

char LetterGrade(double);

int main(void)
{
   const double
      HWWeight = 0.2,         // weight factors for homework,
      TestWeight = 0.5,       //    tests,
      ExamWeight = 0.3;       //    and the exam.

   cout << "\nThis program computes a final course average using the"
        << "\n\thomework average, test average, and a final exam "
        << "score.\n";

   cout << "\nPlease enter homework average, test average, "
        << "and exam score:\n";

   double
      HomeworkAverage,        // the average of the homework scores
      TestAverage,            // the average of the test scores
      ExamScore;              // the final exam score

   cin >> HomeworkAverage >> TestAverage >> ExamScore;

   double
      Average = HWWeight * HomeworkAverage + TestWeight * TestAverage
              + ExamWeight * ExamScore;

   char
      Grade = LetterGrade(Average);    // the grade received (P or F)

   cout << "Average = " << Average << ", Grade = " << Grade << "\n\n";

   return 0;
}

/*------------------------------------------------------------------
 LetterGrade computes the appropriate Grade for a given Average.

   Receive: A (double) weighted average
   Return:  The appropriate (char) letter grade (A, B, C, D, or F)

 ------------------------------------------------------------------*/

char LetterGrade(double Average)
{
   switch (int(Average) / 10)
   {
      case 10:                // int(100)/10 -> 10
      case 9:                 // int(90-99)/10 -> 9
               return'A';
      case 8:                 // int(80-89)/10 -> 8
               return 'B';
      case 7:                 // int(70-79)/10 -> 7
               return 'C';
      case 6:                 // int(60-69)/10 -> 6
               return 'D';
      default:                // not so good!
               return 'F';
   }
}
