/*-------------------------------------------------------------
Convert converts a given Temperature from one scale to another,
   according to the value of Conversion.

   Receive: Temperature, Conversion
   Return:  The equivalent Temperature in the other scale
---------------------------------------------------------------*/

#include "Heat.h"         // library of temperature-
                          //    conversion functions

double Convert(double Temperature, char Conversion)
{
   switch (Conversion)
   {
      case 'a': case 'A':
                          return FahrToCelsius(Temperature);
      case 'b': case 'B':
                          return CelsiusToFahr(Temperature);
      case 'c': case 'C':
                          return FahrToKelvin(Temperature);
      case 'd': case 'D':
                          return KelvinToFahr(Temperature);
      case 'e': case 'E':
                          return KelvinToCelsius(Temperature);
      case 'f': case 'F':
                          return CelsiusToKelvin(Temperature);
      default:
                          cerr << "\n*** Error: Illegal conversion: "
                               << Conversion
                               << " detected in function Convert.\n";
   }
   return 0.0;   // default value in case of error
}
