/* This file provides an interface for library Heat.

   Names declared:
      HeatOfFusion, the amount of heat needed to melt a gram of ice
      HeatOfVaporization, the amount of heat needed to boil a gram
        of water
      FahrToCelsius(), a Fahrenheit-to-Celsius conversion function
      CelsiusToFahr(), a Celsius-to-Fahrenheit conversion function
      FahrToKelvin(), a Fahrenheit-to-Kelvin conversion function
      KelvinToFahr(), a Kelvin-to-Fahrenheit conversion function
      KelvinToCelsius(), a Kelvin-to-Celsius conversion function
      CelsiusToKelvin(), a Celsius-to-Kelvin conversion function
------------------------------------------------------------------*/

const double HeatOfFusion = 79.71;          // calories per gram

const double HeatOfVaporization = 539.55;   // calories per gram

/*----------------------------------------------------------------
FahrToCelsius converts a temperature from Fahrenheit to Celsius.

   Receive:  A Fahrenheit temperature
   Return:   The equivalent Celsius temperature
------------------------------------------------------------------*/

double FahrToCelsius(double FTemp);

/*----------------------------------------------------------------
CelsiusToFahr converts a temperature from Celsius to Fahrenheit.

Receive:  A Celsius temperature
Return:   The equivalent Fahrenheit temperature
------------------------------------------------------------------*/

double CelsiusToFahr(double CTemp);

/*----------------------------------------------------------------
FahrToKelvin converts a temperature from Fahrenheit to Kelvin.

   Receive:  A Fahrenheit temperature
   Return:   The equivalent Kelvin temperature
------------------------------------------------------------------*/

double FahrToKelvin(double FTemp);

/*----------------------------------------------------------------
KelvinToFahr converts a temperature from Kelvin to Fahrenheit.

Receive:  A Kelvin temperature
Return:   The equivalent Fahrenheit temperature
------------------------------------------------------------------*/

double KelvinToFahr(double KTemp);

/*----------------------------------------------------------------
KelvinToCelsius converts a temperature from Kelvin to Celsius.

   Receive:  A Kelvin temperature
   Return:   The equivalent Celsius temperature
------------------------------------------------------------------*/

double KelvinToCelsius(double KTemp);

/*----------------------------------------------------------------
CelsiusToKelvin converts a temperature from Celsius to Kelvin.

Receive:  A Celsius temperature
Return:   The equivalent Kelvinenheit temperature
------------------------------------------------------------------*/

double CelsiusToKelvin(double CTemp);
