/* This file provides an interface for library Deprec.

   Names defined:
      StraightLine(), depreciation using straight-line method
      SumOfYears(), depreciation using sum-of-years-digits method
------------------------------------------------------------------*/

/*-------------------------------------------------------------------
StraightLine computes the depreciation of Amount over NumYears,
   using the straight-line method.

   Receive: A (double) Amount, and (int) NumYears
   Output:  A depreciation table
-------------------------------------------------------------------*/

void StraightLine(double Amount, int NumYears);

/*--------------------------------------------------------------
SumOfYears displays the depreciation of Amount over NumYears,
   using the sum-of-years-digits method.

   Receive: A (double) Amount, and (int) NumYears
   Output:  A depreciation table
----------------------------------------------------------------*/

void SumOfYears(double Amount, int NumYears);
