/* This program computes the mean of a list of component failure
   times.

   Input:   A list of fail times
   Output:  User prompts, number of fail times read, and mean or a
            message indicating that no failure times were entered

   Note: To port the program from UNIX to DOS,
            replace:   EOFMarker[] = "Control-D";
             with      EOFMarker[] = "Control-Z";
------------------------------------------------------------------*/

#include <iostream.h>

int main(void)
{
   const char
      EOFMark[] = "Control-D";

   cout << "\nThis program computes the mean failure time\n"
        << "\tfor a list of component failure times.\n"
        << "\tEntering a failure time of " << EOFMark
        << " signals the end of data.\n\n";

   int
      NumTimes = 0;                // number of failure times
   double
      FailTime,                    // the fail time being processed
      Sum = 0.0;                   // sum of the failure times

                                   // read first fail time
   cout << "Please enter the first failure time ("
        << EOFMark << " to quit): ";
   cin >> FailTime;

   while (!cin.eof())              // while not end of data
   {
      NumTimes++;                 //    process fail time
      Sum += FailTime;

      cout << "Please enter the next failure time ("
           << EOFMark << " to quit): ";
      cin >> FailTime;             //    read next fail time
   }                               // end while loop

   if (NumTimes > 0)
   {
      double
         MeanFailTime = Sum / NumTimes;      // the mean of the fail times

      cout << "\n\t--> The mean of the " << NumTimes
           << " failure times is " << MeanFailTime << "\n\n";
   }
   else
      cout << "\n*** No fail times were entered !\n\n";

   return 0;
}
