/* This is a simple driver program to test function GetMenuChoice().

   Input:  characters Ch (via GetMenuChoice())
   Output: the menu produced by GetMenuChoise and the value of Ch
------------------------------------------------------------------*/

#include <iostream.h>

char GetMenuChoice(void);

int main(void)
{
   cout << "\nThis program tests function GetMenuChoice.\n";

   char
      Ch;

   Ch = GetMenuChoice();

   cout << "\nThank you for selecting transaction "
        << Ch << ", which ...\n\n";

   return 0;
}

/*-----------------------------------------------------------------
   This function simulates the input of an ATM transaction choice,
   using a forever loop.

   Output: a Menu of choices (A-D)
   Input:  Choice, a char indicating the transaction selected
           by the user
   Return: a valid menu option
------------------------------------------------------------------*/

char GetMenuChoice(void)
{
   const char
      Menu[] = "\nPlease enter:"              // the transaction menu
               "\n\tA - to make a withdrawal from your account."
               "\n\tB - to make a deposit to your account."
               "\n\tC - for other transactions."
               "\n\tD - to quit.\n";
   char
      Choice;                                 // the transaction

   for (;;)                                   // Forever loop:
   {
      cout << Menu;                           //   display the menu
      cin >> Choice;                          //   input Choice (A-D)

      if ((Choice >= 'A') && (Choice <= 'D')) //   if a valid Choice:
         break;                               //     exit the loop

      cout << "\nI'm sorry, but " << Choice   //   else display
           << " is not a valid menu"          //     an error message
           << " choice.\n";
   }                                          // End loop

   return Choice;                             // return (valid) choice
}
