/* This program computes the mean of a list of component failure
   times.  It does so using a sentinel-controlled forever loop
   with sentinel value -1.

   Input:   A list of failure times
   Output:  User prompts, number of fail times read, and their
            mean or a message indicating that no failure times
            were entered
------------------------------------------------------------------*/

#include <iostream.h>

int main(void)
{
   const int
      Sentinel = -1;               // the end-of-data indicator

   cout << "\nThis program computes the mean failure time,\n"
        << "\tfor a list of component failure times.\n"
        << "\tEntering a failure time of " << Sentinel
        << " signals the end of data.\n\n";

   int
      NumTimes = 0;                // number of failure times
   double
      FailTime,                    // failure time being processed
      Sum = 0.0;                   // sum of the failure times

   for (;;)                        // forever loop
   {
      cout << "Please enter a failure time ("
           << Sentinel << " to quit): ";
      cin >> FailTime;

      if  (FailTime == Sentinel)   //   if-break combination, that
         break;                    //     tests the sentinel value

      NumTimes++;
      Sum += FailTime;
   }                               // end loop

   if (NumTimes > 0)
   {
      double
         MeanFailTime = Sum / NumTimes;  // the mean failure time

      cout << "\n\t--> The mean of the " << NumTimes
           << " failure times is " << MeanFailTime << "\n\n";
   }
   else
      cout << "\n*** No fail times were entered !\n\n";

   return 0;
}
