/* Find the equation of the least squares line, given a set of
   data points.

   Input:   A set of data points
   Output:  User prompts and equation of least squares line
------------------------------------------------------------------*/

#include <iostream.h>

void DoLeastSquares(void);

int main(void)
{
   cout << "\nGiven a set of data points, this program finds the"
        << "\n\tequation of the least squares line to fit that data "
        << "set.\n\n";

   DoLeastSquares();

   return 0;
}

/*----------------------------------------------------------------
DoLeastSquares performs the least squares algorithm.

   Input:   A set of data points
   Output:  User prompts and equation of least squares line
------------------------------------------------------------------*/

void DoLeastSquares(void)
{
   const char
      EOFMarker[] = "Control-D";

   int
      n = 0;                  // number of data points

   double
      x,                      // x-coordinate of current data point
      y,                      // y-coordinate of current data point
      SumX = 0.0,             // sum of the xs
      SumY = 0.0,             // sum of the ys
      SumX2 = 0.0,            // sum of the squares of the xs
      SumXY = 0.0;            // sum of the x*y products

   cout << "Enter x, y of data point ("    // prompt for input
        << EOFMarker << " to quit) ? ";
   cin >> x;                               // get first x-coordinate

   while (!cin.eof())                      // while not end-of-data
   {
      cin >> y;                            //   get the y-coord
      n++;                                 //   update the count
      SumX += x;                           //   update the sums
      SumY += y;
      SumX2 += (x * x);
      SumXY += (x * y);

      cout << "Enter x, y of data point (" //   prompt for input
        << EOFMarker << " to quit) ? ";
      cin >> x;                            //   get next x-coordinate
   }                                       // end-of-while

   if (n > 0)                              // if positive n,
   {                                       //   compute &
      double                               //     output results:
         XMean = SumX / n,                 //     mean of the xs
         YMean = SumY / n,                 //     mean of the ys
         Slope = (SumXY - SumX * YMean)    //     slope, and
               / (SumX2 - SumX * XMean),
         YIntercept = (YMean - Slope * XMean);
                                           //     y intercept
                                           //  of least squares line

      cout << "\n\n--> The least squares line equation is y = mx + b"
           << "\n\t  whose Slope = m = " << Slope
           << ", and Y-intercept = b = " << YIntercept
           << "\n\n";
   }
   else
      cout << "\n--> No data points to process!\n\n";
}
