/* This file provides an interface for library MyMath.

   Names defined:
      Sum(), a summation function
      Polynomial(), a polynomial calculating function
------------------------------------------------------------------*/

/*-----------------------------------------------------------------
   This function computes the summation from 1 to N, using a
   for loop.

   Receive:  An integer N
   Return:   Tthe value 1 + 2 + ... + N
------------------------------------------------------------------*/

int Sum(int N);

/*-----------------------------------------------------------------
   This function will evaluate a polynomial of any degree.

   Receive: The int Degree, a real value X, and the real
            coefficients a, ... of a polynomial
   Return:  The real value of the polynomial at X
------------------------------------------------------------------*/

double Polynomial(int Degree, double X, double a = 0, ...);
