/* Power computes x raised to the power n recursively.

   Receive:  x, a real value, and
             n, an integer
   Return:   x raised to the power n
----------------------------------------------------------------*/

double Power(double x, int n)
{
   if (n == 0)
      return 1.0;                   // anchor case
   else if (n > 0)
      return Power(x, n - 1) * x;   // inductive step (n > 0)
   else
   {
      cerr << "\n*** Power has received a negative exponent.\n";
      return -1.0;
   }
}
