/* This file provides an interface for library MyStats.

   Names declared:
      EOFMarker, the string indicating the EOF marker
      FindMinMaxAverage(), finds the smallest, largest, and average
------------------------------------------------------------------*/

const char
   EOFMarker[] = "Control-D";

/*-----------------------------------------------------------------
   This function finds the smallest, largest, and average values
   in a list.

   Input:   A sequence of real values
   Return:  Min, the smallest value in the sequence,
            Max, the largest value in the sequence, and
            Average, the average of the values in the sequence
------------------------------------------------------------------*/

void FindMinMaxAverage(double& Min, double& Max, double& Average);
