/* This program inputs a sequence of test scores, finds their mean,
   and displays the scores together with their differences from
   the mean.

   Input:  A sequence of test scores
   Output: The mean of the test scores, all scores with their
           differences from the mean, and prompts for input
------------------------------------------------------------------*/

#include <iostream.h>
#include <iomanip.h>

double Mean(const double[], unsigned);    // function to compute
                                          //   the mean
int main(void)
{
   const int
      ArraySize = 32;                     // number of array elements
   double
      Score[ArraySize];                   // the array of scores

   cout << "\nThis program processes a sequence of up to "
        << ArraySize <<" test"
        << "\n\tscores.  It finds the average of the scores and"
        << "\n\tthe differences of the scores from the average.\n\n"
        << "How many scores are there to process? ";

   int
      NumScores;                          // number of scores
   cin >> NumScores;

   for (int i = 0; i < NumScores; i++)    // loop to input scores
   {
      cout << "Please enter score "       //   display prompt
           << (i+1) << ": ";
      cin >> Score[i];                    //   store score in array
   }

   double
      MeanScore = Mean(Score, NumScores); // find the mean score

   cout << "\n\nThe mean score is "       // display the mean
        << MeanScore << ".\n\n";
   cout.setf(ios::showpoint | ios::fixed);
   cout.precision(1);

   cout << "Scores and (differences):\n"; // display scores and
   for (i = 0; i < NumScores; i++)        //   differences from mean
      cout << "\tScore " << (i+1)
           << ": " << Score[i]
           << "\t(" << (Score[i] - MeanScore)
           << ")\n";

    return 0;
}

/*-----------------------------------------------------------------
This function computes the mean of values stored in an array.

   Receive: Array, an array of double values
            NumValues, the number of values stored in the array
   Return:  The mean of the values
------------------------------------------------------------------*/

double Mean(const double Array[], unsigned NumValues)
{
   if (NumValues <= 0)                    // avoid division by zero
   {
      cerr << "\n*** No elements passed to Mean!\n";
      return 0.0;
   }

   double
      Sum = 0.0;                          // sum of the scores

   for (int i = 0; i < NumValues; i++)    // sum the array elements
      Sum += Array[i];

   return Sum / NumValues;                // compute the mean value
}
