/* This function simulates the input of an ATM transaction choice,
   using a Set and some of its operations.

   Output: A Menu of choices (A-D)
   Input:  The user's Choice
   Return: Choice, guaranteed to be one of {A, B, C, D}
------------------------------------------------------------------*/

#include "Set.h"

char GetMenuChoice(void)
{
   const char                             // the prompt
      Menu[] = "\nPlease enter:\n"
         "A - to make a withdrawal from your account.\n"
         "B - to make a deposit to your account.\n"
         "C - for other transactions.\n"
         "D - to quit.\n--->";
   Set                                  // declare the Set
      ValidChoices(4, 'A', 'B', 'C', 'D');

   char
      Response;                         // the user's response

   do                                   // Loop:
   {
      cout << Menu;                     //   display the menu
      cin >> Response;                  //   get their response
   }                                    // until response is valid
   while (!ValidChoices.Contains(Response));

   return Response;                     // return the valid response
}
