/* This program can be used to graph an arbitrary function(s) 
   using class CartesianSystem.

   Output: Prompts for input
   Input:  Values for the endpoints of the x and y axes
   Output: The graphs of f(x) and g(x)

   Note:  In this example, two functions f(x) and g(x) are plotted.
------------------------------------------------------------------*/

#include <iostream.h>
#include <math.h>

#include "CartSys.h"                // declaration of CartesianSystem

double f(double x)                  // a function to be plotted
{
    return x * cos(x);
}

double g(double x)                  // another function to be plotted
{
    return x;
}

int main(void)
{
    cout << "\nThis program plots some functions..."
         << "\n(currently y = x*cos(x) and y = x.)\n";

    double                          // endpoints of the axes
        xMin, xMax,
        yMin, yMax;
    char
        ReturnChar;                 // the newline

    do                              // get the x bounds
    {
        cout << "\nPlease enter the minimum and maximum x values: ";
        cin >> xMin >> xMax;
    }
    while (xMin >= xMax);

    do                              // get the y bounds
    {
        cout << "\nPlease enter the minimum and maximum y values: ";
        cin >> yMin >> yMax;
    }
    while (yMin >= yMax);

    cin.get(ReturnChar);            // clean out the newline

    CartesianSystem                 // construct a Cartesian system
        CoordinateSys(xMin, xMax, yMin, yMax);

    CoordinateSys.DrawAxes();       // draw the axes

    CoordinateSys.Graph(f);         // graph f

    CoordinateSys.Graph(g, CYAN);   // graph g in a different color

    return 0;
}
