/* This program can be used to draw a control plot of an arbitrary
   function z = f(x, y) using class CartesianSystem.

   Output: Prompts for input
   Input:  Values for the endpoints of the x and y axes
   Output: The graphs of f(x) and g(x)

--------------------------------------------------------------------*/

#include <iostream.h>
#include <math.h>

#include "CartSys.h"              // declaration of CartesianSystem

double f(double x, double y)      // f(x,y)
{
    return exp( -(x*x + y*y) );
}

int main(void)
{
    cout << "\nThis program does a density plot of a function..."
         << "\n\t(currently z = e^(-x^2 + y^2).)\n";

    double                        // axes endpoints
        xMin, xMax,
        yMin, yMax,
        zMin, zMax;
    char
        ReturnChar;               // the newline

    do                            // get x-axis endpoints
    {
        cout << "\nPlease enter the minimum and maximum x values: ";
        cin >> xMin >> xMax;
    }
    while (xMin >= xMax);

    do                            // get y-axis endpoints
    {
        cout << "\nPlease enter the minimum and maximum y values: ";
        cin >> yMin >> yMax;
    }
    while (yMin >= yMax);

    do                            // get z-axis endpoints
    {
        cout << "\nPlease enter the minimum and maximum z values: ";
        cin >> zMin >> zMax;
    }
    while (zMin >= zMax);

    cin.get(ReturnChar);          // clean out the newline

    CartesianSystem               // construct the cartesian system
        CoordinateSys(xMin, xMax, yMin, yMax, zMin, zMax);

    CoordinateSys.DensityPlot(f); // plot the function

    return 0;
}
